
.nolist

#include	"asm83.inc"

#define	SwapBytes	swap-loader_start+$9157+data
#define	data		$02
#define	prgmName	$913B

.list
.org	$9327


_main:
	call	_indicoff
	set	0,(iy+3)
	call	ClearScreens

	call	_zeroop1
	ld	hl,prgmName
	rst	20h
	call	_findsym
	ret	c

	ex	de,hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ex	de,hl
	ld	hl,-9
	add	hl,bc
	push	hl
	ld	hl,9+1+1
	add	hl,de
	push	hl

runAsm:
	ld	a,(hl)
	cp	$18
	jr	nz,none_sos
	ld	d,h
	ld	e,l
	inc	hl
	inc	hl
	call	_ldhlind
	dec	de
	ld	a,h
	or	l
	jr	z,nolibs
	add	hl,de

libll:
	dec	hl
	rst	20h
	ld	a,5
	ld	(op1),a
	push	hl
	call	_findsym
	inc	de
	inc	de
	pop	hl
	jr	nc,libfnd

libNotFound:
	pop	bc
	pop	hl
	ld	de,$3901
	ld	(pencol),de
	ld	hl,error
	call	_vputs
	ld	hl,op1+1
	jp	_vputs

libfnd:
	ld	c,(hl)
	push	hl
	ex	de,hl
	push	hl
	add	hl,bc
	call	_ldhlind
	pop	de
	add	hl,de
	ex	de,hl
	pop	hl
	inc	hl
	ld	c,(hl)
	push	hl
	ld	hl,cmdshad+40
	add	hl,bc
	ld	(hl),$C3
	inc	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	pop	hl
	inc	hl
	ld	a,(hl)
	inc	a
	jr	nz,libll
libdone:

nolibs:
none_sos:
	ld	hl,loader_start
	ld	de,$9157+data
	ld	bc,loader_end-loader_start
	ldir

	pop	de
	dec	de
	pop	bc
	ld	hl,$9327
	call	$9157+data


	call	ClearScreens
	call	_gohome

Exit:
ClearScreens:
	call	_bufclr
	jp	_clrAllScrn


error:	.db	"ERROR:",0


loader_start:

	push	bc
ex1:	call	SwapBytes
	inc	hl
	inc	de
	jr	nz,ex1
	push	de
	push	hl
	call	$9327
	pop	hl
	pop	de
	pop	bc
ex2:	dec	hl
	dec	de
	call	SwapBytes
	jr	nz,ex2
	ret
swap:	ld	a,(hl)
	push	af
	ld	a,(de)
	ld	(hl),a
	pop	af
	ld	(de),a
	dec	bc
	ld	a,b
	or	c
	ret

loader_end:


_end:

.end

